//PlayLayer
//a multi format play library that is built on top of the modified Game_Music_Emu
//and extra libraries with an unified interface
//to allow more formats in 1tracker

#ifndef PLAYLAYER_H
#define PLAYLAYER_H

#include <cstddef>
#include "../libs/gme/gme.h"

enum {
	PLL_BACKEND_GME,
	PLL_BACKEND_Z80
};

class PlayLayer {
private:
	bool playing;
	int backend;
	Music_Emu* gme_emu;

	void PlayLayerHandleGMEError(gme_err_t error, const char * name);

public:
	PlayLayer();
	~PlayLayer();
	void Play(const unsigned char* data, size_t data_size, int sample_rate);
	void Stop();
	void Render(short int* buf, int samples);
};

#endif	//PLAYLAYER_H