int selectFileReturnMode;

vector<string> selectFile=vector<string>();
int selectFileCount;
int selectFileCursor;
const char* selectFileHeader = NULL;
char selectFilePath[MAXPATH] = "\0";
char selectFileFile[MAXPATH] = "\0";
int selectFileID = 0;
char* selectFileLastSelectedFilePtr = NULL;
unsigned int selectFileLastSelectedFileSize = 0;
bool selectFileLastSelectedHighlight;
char selectFileFileCopy[MAXPATH] = "\0";
char* selectFileOriginalPathPtr = NULL;
unsigned int selectFileOriginalPathSize = 0;
char selectFileFilter[MAXPATH] = "\0";
bool selectFileDirectories;
bool selectFileSaveMode;
bool selectFileShowOverwrite;
bool selectFileOverwrite;
char selectFilePrevDir[MAXPATH] = "\0";
int selectFileEvent;

char selectFileSongLast[MAXPATH] = "\0";
char selectFileInstrumentLast[MAXPATH] = "\0";
char selectFileImportLast[MAXPATH] = "\0";
char selectFileExportLast[MAXPATH] = "\0";



void free_file_list(void)
{
	selectFile.clear();
	selectFileCount = 0;
	selectFileCursor = 0;
}



void build_file_list(void)
{
	char tempName[MAXPATH];
	DIR *dp;
	struct dirent *dirp;

	free_file_list();

	if(selectFileDirectories)
	{
		dp = opendir(selectFilePath);

		if(dp)
		{
			for (int pri = 0; pri < 2; ++pri)	//populate list with directories twice, put ones starting with _ first
			{
				rewinddir(dp);

				while (1)
				{
					dirp = readdir(dp);

					if (!dirp) break;

					if (dirp->d_type == DT_DIR)
					{
						if (strcmp(dirp->d_name, "."))
						{
							if ((!pri && (dirp->d_name[0] == '_' || dirp->d_name[0] == '.')) || (pri && (dirp->d_name[0] != '_'&&dirp->d_name[0] != '.')))
							{
								selectFile.push_back("!" + string(dirp->d_name));

								if (!strncmp(dirp->d_name, selectFilePrevDir, sizeof(dirp->d_name))) selectFileCursor = selectFileCount;

								++selectFileCount;
							}
						}
					}
				}
			}

			closedir(dp);
		}
	}

	int last_off = 0;

	if (selectFileLastSelectedFilePtr)
	{
		for (int i = strlen(selectFileLastSelectedFilePtr) - 1; i >= 0; --i)
		{
			if (selectFileLastSelectedFilePtr[i] == '\\' || selectFileLastSelectedFilePtr[i] == '/')
			{
				last_off = i + 1;
				break;
			}
		}
	}

	dp = opendir(selectFilePath);

	if(dp)
	{
		for (int pri = 0; pri < 2; ++pri)	//populate list with files twice, put ones starting with _ first
		{
			rewinddir(dp);

			while (1)
			{
				dirp = readdir(dp);

				if (!dirp) break;

				if (dirp->d_type == DT_REG)
				{
					strncpy(tempName, dirp->d_name, sizeof(tempName));

					for (int i = strlen(tempName) - 1; i >= 0; --i)
					{
						if (tempName[i] != ' ') break;

						tempName[i] = 0;
					}

					if (!strcmp(&tempName[strlen(dirp->d_name) - strlen(selectFileFilter)], selectFileFilter))
					{
						if ((!pri && dirp->d_name[0] == '_') || (pri && dirp->d_name[0] != '_'))
						{
							selectFile.push_back(" " + string(tempName));

							if (selectFileLastSelectedHighlight)
							{
								if (!strncmp(dirp->d_name, &selectFileLastSelectedFilePtr[last_off], sizeof(dirp->d_name))) selectFileCursor = selectFileCount;
							}

							++selectFileCount;
						}
					}
				}
			}
		}

		closedir(dp);
	}

	if(selectFileSaveMode)
	{
		selectFile.push_back("*[New file]");

		if (selectFileCursor == 0) selectFileCursor = selectFileCount;

		++selectFileCount;
	}

	if (selectFileCursor >= selectFileCount) selectFileCursor = 0;

	selectFileLastSelectedHighlight = false;
}



void set_select_file(const char* header, char* path, unsigned int path_size, int mode, const char* filter, bool dirs, int event, char *last, unsigned int last_size, int save_mode, int file_id)
{
	selectFileLastSelectedFilePtr = last;
	selectFileLastSelectedFileSize = last_size;
	selectFileLastSelectedHighlight = true;
	selectFileReturnMode = mode;
	selectFileHeader = header;
	selectFileOriginalPathPtr = path;
	selectFileOriginalPathSize = path_size;
	strncpy(selectFileFilter, filter, sizeof(selectFileFilter));
	selectFileDirectories = dirs;
	selectFileSaveMode = save_mode;
	selectFileShowOverwrite = false;
	selectFileEvent = event;
	selectFileID = file_id;

	strncpy(selectFilePath, path, sizeof(selectFilePath));
	strncpy(selectFileFile, "untitled", sizeof(selectFileFile));
	strncat(selectFileFile, filter, sizeof(selectFileFile));
	strncpy(selectFilePrevDir, "", sizeof(selectFilePrevDir));

	for (unsigned int i = 0; i < strlen(selectFilePath); ++i)
	{
		if (selectFilePath[i] == '\\') selectFilePath[i] = '/';
	}

	build_file_list();

	set_edit_mode(MODE_SELECT_FILE);
}



int get_file_list_top_row(void)
{
	int file = 0;
	int hgt = PATTERN_HEIGHT;

	if (selectFileCount > hgt)
	{
		file = selectFileCursor - hgt / 2;

		if (file < 0) file = 0;

		if (file > selectFileCount - hgt) file = selectFileCount - hgt;
	}

	return file;
}



void draw_select_file(void)
{
	unsigned char color = selectFileSaveMode ? COL_HEADER_MUTE : COL_HEADER;

	for (int i = 0; i < textScreenWidth; ++i)
	{
		PUT_ATTR(i, 0, color);
		PUT_ATTR(i, textScreenHeight - 1, color);
	}

	put_str(1, 0, (char*)selectFileHeader, color);
	put_str_file(1, textScreenHeight - 1, selectFilePath, color);

	int file_top_row = get_file_list_top_row();
	int file = file_top_row;

	for (int i = 0; i < PATTERN_HEIGHT; ++i)
	{
		if (file >= selectFileCount) break;

		color = COL_PROGRAM_BACKGROUND;

		if (selectFile[file].c_str()[0] == '!') color = COL_DIRECTORY;

		if (file == selectFileCursor) color = COL_CURSOR_ROW;

		const char* str = &selectFile[file].c_str()[1];

		put_str_file(PATTERN_XPOS + 2, PATTERN_YPOS + i, file == selectFileCursor ? ">" : " ", color);
		put_str_file(PATTERN_XPOS + 3, PATTERN_YPOS + i, (char*)str, color);
		put_str_file(PATTERN_XPOS + 3 + strlen(str), PATTERN_YPOS + i, " ", color);

		++file;
	}

	char cu = ' ';
	char cd = ' ';

	if (file_top_row > 0) cu = 16;
	if ((file_top_row + PATTERN_HEIGHT) < selectFileCount) cd = 17;

	PUT_CHAR_ATTR(PATTERN_XPOS + 1, 2, cu, COL_DIRECTORY);
	PUT_CHAR_ATTR(PATTERN_XPOS + 1, 3, cu, COL_DIRECTORY);
	PUT_CHAR_ATTR(PATTERN_XPOS + 1, textScreenHeight - 4, cd, COL_DIRECTORY);
	PUT_CHAR_ATTR(PATTERN_XPOS + 1, textScreenHeight - 3, cd, COL_DIRECTORY);

	if(selectFileShowOverwrite)
	{
		put_str(PATTERN_XPOS + 2, PATTERN_XPOS + 1 + selectFileCursor - file_top_row, " File already exists, overwrite? (Y/N) ", COL_CURSOR);
	}
}



void move_file_list_cursor(int offset)
{
	selectFileCursor+=offset;

	if(selectFileCursor<0) selectFileCursor=0;
	if(selectFileCursor>=selectFileCount-1) selectFileCursor=selectFileCount-1;
}



void select_file_done(void)
{
	SDL_Event userEvent;

	if (selectFileEvent == EVENT_LOAD_SONG) module.columns = 0;

	strncpy(selectFileOriginalPathPtr, selectFilePath, selectFileOriginalPathSize);

	free_file_list();

	set_edit_mode(selectFileReturnMode);

	userEvent.type = SDL_USEREVENT;
	userEvent.user.code = selectFileEvent;
	userEvent.user.data1 = selectFileFile;
	userEvent.user.data2 = &selectFileID;

	SDL_PushEvent(&userEvent);
}



bool file_exists(char* filename)
{
	FILE *file = xfopen(filename, "rb");

	if(file)
	{
		xfclose(file);
		return true;
	}

	return false;
}



void file_list_add_extension(char* filename,unsigned int filename_size)
{
	if(!strcmp(&filename[strlen(filename)-strlen(selectFileFilter)],selectFileFilter)) return;

	strncat(filename, selectFileFilter, filename_size);
}



void leave_directory(void)
{
	unsigned int i = strlen(selectFilePath) - 1;

	while (i)
	{
		--i;

		if (selectFilePath[i] == '/' || selectFilePath[i] == '\\')
		{
			memset(selectFilePrevDir, 0, sizeof(selectFilePrevDir));
			strncpy(selectFilePrevDir, &selectFilePath[i + 1], sizeof(selectFilePrevDir));
			selectFilePrevDir[strlen(selectFilePrevDir) - 1] = 0; 
			
			selectFilePath[i + 1] = 0;

			break;
		}
	}

	strncpy(selectFileOriginalPathPtr, selectFilePath, selectFileOriginalPathSize);
}



void enter_directory(void)
{
	strncat(selectFilePath, &selectFile[selectFileCursor].c_str()[1], sizeof(selectFilePath));
	strncat(selectFilePath, "/", sizeof(selectFilePath));

	strncpy(selectFileOriginalPathPtr, selectFilePath, selectFileOriginalPathSize);
}



void select_file_events(SDL_Event event)
{
	if(editMode==MODE_SELECT_FILE_INPUT_DONE)
	{
		if(inputDone)
		{
			strncpy(selectFileFileCopy, selectFileFile, sizeof(selectFileFileCopy));
			strncpy(selectFileFile, selectFilePath, sizeof(selectFileFile));
			strncat(selectFileFile, selectFileFileCopy, sizeof(selectFileFile));

			file_list_add_extension(selectFileFile, sizeof(selectFileFile));

			strncpy(selectFileLastSelectedFilePtr, selectFileFileCopy, selectFileLastSelectedFileSize);
			file_list_add_extension(selectFileLastSelectedFilePtr, selectFileLastSelectedFileSize);
			set_edit_mode(MODE_SELECT_FILE_OVERWRITE);
		}
	}

	if(editMode==MODE_SELECT_FILE_OVERWRITE)
	{
		file_list_add_extension(selectFileFile, sizeof(selectFileFile));

		if(!file_exists(selectFileFile))
		{
			select_file_done();
		}
		else
		{
			set_edit_mode(MODE_SELECT_FILE);
			selectFileShowOverwrite=true;
		}

		return;
	}

	switch(event.type)
	{
	case SDL_KEYDOWN:
		{
			if(selectFileShowOverwrite)
			{
				switch(event.key.keysym.sym)
				{
				case SDLK_y:
					{
						select_file_done();
					}
					break;

				case SDLK_n:
					{
						strncpy(selectFileFile, selectFileFileCopy, sizeof(selectFileFile));
						selectFileShowOverwrite=false;
					}
					break;
				}
			}
			else
			{
				switch(event.key.keysym.sym)
				{
				case SDLK_ESCAPE:
					{
						strncpy(selectFileFile, "", sizeof(selectFileFile));
						free_file_list();
						set_edit_mode(selectFileReturnMode);
					}
					break;

				case SDLK_RETURN:
					{
						if(selectFileSaveMode)
						{
							if(selectFile[selectFileCursor].c_str()[0]=='*')
							{
								set_input_string(PATTERN_XPOS + 3, PATTERN_YPOS + selectFileCursor - get_file_list_top_row(), textScreenWidth - 2, MODE_SELECT_FILE_INPUT_DONE, true, selectFileFile, NULL);
								break;
							}
						}

						if(selectFile[selectFileCursor].c_str()[0]=='!')	//a directory
						{
							if(!strcmp(&selectFile[selectFileCursor].c_str()[1],".."))	//go up a directory
							{
								leave_directory();								
							}
							else
							{
								enter_directory();
							}

							build_file_list();
						}
						else
						{
							strncpy(selectFileFile, selectFilePath, sizeof(selectFileFile));
							strncat(selectFileFile, &selectFile[selectFileCursor].c_str()[1], sizeof(selectFileFile));
							strncpy(selectFileLastSelectedFilePtr, selectFileFile, selectFileLastSelectedFileSize);

							if(selectFileSaveMode)
							{
								set_edit_mode(MODE_SELECT_FILE_OVERWRITE);
							}
							else
							{
								select_file_done();
							}
						}
					}
					break;

				case SDLK_UP:
					{
						move_file_list_cursor(-1);
					}
					break;

				case SDLK_DOWN:
					{
						move_file_list_cursor(1);
					}
					break;

				case SDLK_PAGEUP:
					{
						move_file_list_cursor(-PATTERN_HEIGHT);
					}
					break;

				case SDLK_PAGEDOWN:
					{
						move_file_list_cursor(PATTERN_HEIGHT);
					}
					break;

				case SDLK_HOME:
					{
						selectFileCursor=0;
					}
					break;

				case SDLK_END:
					{
						selectFileCursor=selectFileCount-1;
					}
					break;
				}
			}
		}
		break;
	}
}