//a wide char cross-platform replacement for fopen etc functions
//all systems that just accept UTF8 as a filename,
//but Windows it uses UTF16 and a separate set of functions such as _wfopen

#define xfclose		fclose
#define xfseek		fseek
#define xftell		ftell
#define xfread		fread
#define xfwrite		fwrite
#define xfgets		fgets
#define xfprintf	fprintf
#define xfflush		fflush

#ifndef WINDOWS

#define xfopen		fopen

#else

FILE *xfopen(const char *fname, const char *mode)
{
	std::wstring filePathW;
	std::wstring fileModeW; 
	
	filePathW.resize(strlen(fname) * 2);
	fileModeW.resize(strlen(mode) * 2); 
	
	int filePathSize = MultiByteToWideChar(CP_UTF8, 0, fname, strlen(fname), const_cast<wchar_t *>(filePathW.c_str()), strlen(fname));
	int fileModeSize = MultiByteToWideChar(CP_UTF8, 0, mode, strlen(mode), const_cast<wchar_t *>(fileModeW.c_str()), strlen(mode));

	filePathW.resize(filePathSize);
	fileModeW.resize(fileModeSize);

	return _wfopen(filePathW.c_str(), fileModeW.c_str());
}

#endif